> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.agentmachines.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.agentmachines.io/_mcp/server.

# List services

GET https://api.agentmachines.app/apis/serving.agentmachines.app/v1/namespaces/{namespace}/services

Lists Agent Machines services in a namespace.

Reference: https://docs.agentmachines.io/api-reference/agent-machines-admin-api/services/list-services

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: agentmachines-v3-wasm-openapi
  version: 1.0.0
paths:
  /apis/serving.agentmachines.app/v1/namespaces/{namespace}/services:
    get:
      operationId: list-services
      summary: List services
      description: Lists Agent Machines services in a namespace.
      tags:
        - subpackage_services
      parameters:
        - name: namespace
          in: path
          description: Project, organization, or tenant namespace that owns the service.
          required: true
          schema:
            type: string
        - name: limit
          in: query
          description: Maximum number of services to return.
          required: false
          schema:
            type: integer
        - name: continue
          in: query
          description: Continuation token returned by a previous list request.
          required: false
          schema:
            type: string
        - name: Authorization
          in: header
          description: Bearer authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: A page of services.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListServicesResponse'
        '400':
          description: The request is malformed or fails validation.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '401':
          description: Authentication is missing or invalid.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '403':
          description: The caller does not have permission to access the resource.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
servers:
  - url: https://api.agentmachines.app
    description: Agent Machines control plane
components:
  schemas:
    ListMeta:
      type: object
      properties:
        resourceVersion:
          type: string
        continue:
          type: string
      description: Metadata for paginated list responses.
      title: ListMeta
    AgentMachinesServiceApiVersion:
      type: string
      enum:
        - serving.agentmachines.app/v1
      description: Agent Machines service API version.
      title: AgentMachinesServiceApiVersion
    AgentMachinesServiceKind:
      type: string
      enum:
        - Service
      description: Resource kind.
      title: AgentMachinesServiceKind
    ServiceLabels:
      type: object
      properties:
        api.agentmachines.app/location:
          type: string
          description: Region or placement location for the service.
      description: Labels attached to a service.
      title: ServiceLabels
    ServiceAnnotationsApiAgentmachinesAppLaunchStage:
      type: string
      enum:
        - ALPHA
        - BETA
        - GA
      description: Launch stage for preview or generally available features.
      title: ServiceAnnotationsApiAgentmachinesAppLaunchStage
    ServiceAnnotationsApiAgentmachinesAppIngress:
      type: string
      enum:
        - all
        - internal
        - internal-and-load-balancing
      description: Ingress policy.
      title: ServiceAnnotationsApiAgentmachinesAppIngress
    ServiceAnnotationsApiAgentmachinesAppInvokerIamDisabled:
      type: string
      enum:
        - 'true'
        - 'false'
      description: Whether invoker IAM checks are disabled.
      title: ServiceAnnotationsApiAgentmachinesAppInvokerIamDisabled
    ServiceAnnotationsApiAgentmachinesAppIapEnabled:
      type: string
      enum:
        - 'true'
        - 'false'
      description: Whether identity-aware proxy is enabled.
      title: ServiceAnnotationsApiAgentmachinesAppIapEnabled
    ServiceAnnotationsApiAgentmachinesAppScalingMode:
      type: string
      enum:
        - automatic
        - manual
      description: Scaling mode for the service.
      title: ServiceAnnotationsApiAgentmachinesAppScalingMode
    ServiceAnnotations:
      type: object
      properties:
        api.agentmachines.app/custom-audiences:
          type: string
          description: JSON array string of accepted audiences.
        api.agentmachines.app/launch-stage:
          $ref: >-
            #/components/schemas/ServiceAnnotationsApiAgentmachinesAppLaunchStage
          description: Launch stage for preview or generally available features.
        api.agentmachines.app/description:
          type: string
          description: Human-readable service description.
        api.agentmachines.app/ingress:
          $ref: '#/components/schemas/ServiceAnnotationsApiAgentmachinesAppIngress'
          description: Ingress policy.
        api.agentmachines.app/binary-authorization:
          type: string
          description: Binary authorization policy name.
        api.agentmachines.app/binary-authorization-breakglass:
          type: string
          description: Justification for bypassing binary authorization.
        api.agentmachines.app/minScale:
          type: string
          description: Minimum service-level instance count.
        api.agentmachines.app/maxScale:
          type: string
          description: Maximum service-level instance count.
        api.agentmachines.app/function-target:
          type: string
          description: Function entry point for function-style services.
        api.agentmachines.app/invoker-iam-disabled:
          $ref: >-
            #/components/schemas/ServiceAnnotationsApiAgentmachinesAppInvokerIamDisabled
          description: Whether invoker IAM checks are disabled.
        api.agentmachines.app/iap-enabled:
          $ref: '#/components/schemas/ServiceAnnotationsApiAgentmachinesAppIapEnabled'
          description: Whether identity-aware proxy is enabled.
        api.agentmachines.app/scalingMode:
          $ref: >-
            #/components/schemas/ServiceAnnotationsApiAgentmachinesAppScalingMode
          description: Scaling mode for the service.
        api.agentmachines.app/manualInstanceCount:
          type: string
          description: Number of instances when manual scaling is enabled.
      description: Service-level Agent Machines annotations.
      title: ServiceAnnotations
    ObjectMeta:
      type: object
      properties:
        name:
          type: string
          description: Resource name.
        namespace:
          type: string
          description: Namespace, project, or tenant that owns the resource.
        labels:
          $ref: '#/components/schemas/ServiceLabels'
        annotations:
          $ref: '#/components/schemas/ServiceAnnotations'
        generateName:
          type: string
          description: Optional prefix used by the server when generating a name.
        uid:
          type: string
        resourceVersion:
          type: string
        generation:
          type: integer
          format: int64
        creationTimestamp:
          type: string
          format: date-time
        deletionTimestamp:
          type: string
          format: date-time
        finalizers:
          type: array
          items:
            type: string
      required:
        - name
        - namespace
      description: Metadata common to persisted Agent Machines resources.
      title: ObjectMeta
    RevisionAnnotationsApiAgentmachinesAppCpuThrottling:
      type: string
      enum:
        - 'true'
        - 'false'
      description: Whether CPU is throttled outside request handling.
      title: RevisionAnnotationsApiAgentmachinesAppCpuThrottling
    RevisionAnnotationsApiAgentmachinesAppStartupCpuBoost:
      type: string
      enum:
        - 'true'
        - 'false'
      description: Whether startup CPU boost is enabled.
      title: RevisionAnnotationsApiAgentmachinesAppStartupCpuBoost
    RevisionAnnotationsApiAgentmachinesAppSessionAffinity:
      type: string
      enum:
        - 'true'
        - 'false'
      description: Whether clients should be routed to the same instance when possible.
      title: RevisionAnnotationsApiAgentmachinesAppSessionAffinity
    RevisionAnnotationsApiAgentmachinesAppExecutionEnvironment:
      type: string
      enum:
        - gen1
        - gen2
      description: Execution environment generation.
      title: RevisionAnnotationsApiAgentmachinesAppExecutionEnvironment
    RevisionAnnotationsApiAgentmachinesAppVpcAccessEgress:
      type: string
      enum:
        - all-traffic
        - private-ranges-only
      description: Egress policy for VPC access.
      title: RevisionAnnotationsApiAgentmachinesAppVpcAccessEgress
    RevisionAnnotationsApiAgentmachinesAppGpuZonalRedundancyDisabled:
      type: string
      enum:
        - 'true'
        - 'false'
      description: Whether GPU zonal redundancy is disabled.
      title: RevisionAnnotationsApiAgentmachinesAppGpuZonalRedundancyDisabled
    RevisionAnnotations:
      type: object
      properties:
        autoscaling.agentmachines.app/minScale:
          type: string
          description: Minimum instances for a revision.
        autoscaling.agentmachines.app/maxScale:
          type: string
          description: Maximum instances for a revision.
        api.agentmachines.app/scaling-cpu-target:
          type: string
          description: Target average CPU utilization percentage.
        api.agentmachines.app/scaling-concurrency-target:
          type: string
          description: Target concurrent requests per instance.
        api.agentmachines.app/cpu-throttling:
          $ref: >-
            #/components/schemas/RevisionAnnotationsApiAgentmachinesAppCpuThrottling
          description: Whether CPU is throttled outside request handling.
        api.agentmachines.app/startup-cpu-boost:
          $ref: >-
            #/components/schemas/RevisionAnnotationsApiAgentmachinesAppStartupCpuBoost
          description: Whether startup CPU boost is enabled.
        api.agentmachines.app/sessionAffinity:
          $ref: >-
            #/components/schemas/RevisionAnnotationsApiAgentmachinesAppSessionAffinity
          description: Whether clients should be routed to the same instance when possible.
        api.agentmachines.app/cloudsql-instances:
          type: string
          description: Comma-separated Cloud SQL-style connection names.
        api.agentmachines.app/execution-environment:
          $ref: >-
            #/components/schemas/RevisionAnnotationsApiAgentmachinesAppExecutionEnvironment
          description: Execution environment generation.
        api.agentmachines.app/vpc-access-connector:
          type: string
          description: Serverless VPC connector name.
        api.agentmachines.app/vpc-access-egress:
          $ref: >-
            #/components/schemas/RevisionAnnotationsApiAgentmachinesAppVpcAccessEgress
          description: Egress policy for VPC access.
        api.agentmachines.app/network-interfaces:
          type: string
          description: JSON array string describing network interfaces.
        api.agentmachines.app/encryption-key:
          type: string
          description: Customer-managed encryption key resource name.
        api.agentmachines.app/container-dependencies:
          type: string
          description: JSON object string describing container startup order.
        api.agentmachines.app/base-images:
          type: string
          description: JSON object string mapping container names to base images.
        api.agentmachines.app/gpu-zonal-redundancy-disabled:
          $ref: >-
            #/components/schemas/RevisionAnnotationsApiAgentmachinesAppGpuZonalRedundancyDisabled
          description: Whether GPU zonal redundancy is disabled.
      description: Revision-level Agent Machines annotations.
      title: RevisionAnnotations
    RevisionTemplateMeta:
      type: object
      properties:
        name:
          type: string
          description: Optional revision name.
        labels:
          type: object
          additionalProperties:
            type: string
        annotations:
          $ref: '#/components/schemas/RevisionAnnotations'
      description: Metadata applied to a generated revision.
      title: RevisionTemplateMeta
    NodeSelector:
      type: object
      properties:
        api.agentmachines.app/accelerator:
          type: string
          description: Accelerator type requested by the revision.
      description: Placement constraints for revision instances.
      title: NodeSelector
    ContainerPortName:
      type: string
      enum:
        - http1
        - h2c
      description: Port protocol name.
      title: ContainerPortName
    ContainerPort:
      type: object
      properties:
        name:
          $ref: '#/components/schemas/ContainerPortName'
          description: Port protocol name.
        containerPort:
          type: integer
      required:
        - containerPort
      description: Exposed container port.
      title: ContainerPort
    SecretKeySelector:
      type: object
      properties:
        name:
          type: string
          description: Secret name.
        key:
          type: string
          description: Secret version or alias.
        optional:
          type: boolean
      required:
        - name
        - key
      description: Selects a version from a secret.
      title: SecretKeySelector
    EnvVarSource:
      type: object
      properties:
        secretKeyRef:
          $ref: '#/components/schemas/SecretKeySelector'
      description: Source for an environment variable value.
      title: EnvVarSource
    EnvVar:
      type: object
      properties:
        name:
          type: string
          description: Environment variable name.
        value:
          type: string
          description: Literal environment variable value.
        valueFrom:
          $ref: '#/components/schemas/EnvVarSource'
      required:
        - name
      description: Environment variable.
      title: EnvVar
    ResourceRequirementsLimits:
      type: object
      properties:
        cpu:
          type: string
          description: CPU limit.
        memory:
          type: string
          description: Memory limit.
        nvidia.com/gpu:
          type: string
          description: Number of GPUs requested.
      description: Resource limits keyed by resource name.
      title: ResourceRequirementsLimits
    ResourceRequirements:
      type: object
      properties:
        limits:
          $ref: '#/components/schemas/ResourceRequirementsLimits'
          description: Resource limits keyed by resource name.
      description: Container resource requirements.
      title: ResourceRequirements
    VolumeMount:
      type: object
      properties:
        name:
          type: string
        mountPath:
          type: string
      required:
        - name
        - mountPath
      description: Mount point for a named volume.
      title: VolumeMount
    HTTPHeader:
      type: object
      properties:
        name:
          type: string
        value:
          type: string
      required:
        - name
        - value
      title: HTTPHeader
    HTTPGetAction:
      type: object
      properties:
        path:
          type: string
          default: /
        port:
          type: integer
        httpHeaders:
          type: array
          items:
            $ref: '#/components/schemas/HTTPHeader'
      required:
        - port
      description: HTTP probe handler.
      title: HTTPGetAction
    TCPSocketAction:
      type: object
      properties:
        port:
          type: integer
      required:
        - port
      description: TCP probe handler.
      title: TCPSocketAction
    GRPCAction:
      type: object
      properties:
        service:
          type: string
          description: Optional gRPC service name.
        port:
          type: integer
      required:
        - port
      description: gRPC probe handler.
      title: GRPCAction
    Probe:
      type: object
      properties:
        httpGet:
          $ref: '#/components/schemas/HTTPGetAction'
        tcpSocket:
          $ref: '#/components/schemas/TCPSocketAction'
        grpc:
          $ref: '#/components/schemas/GRPCAction'
        initialDelaySeconds:
          type: integer
        timeoutSeconds:
          type: integer
        successThreshold:
          type: integer
        failureThreshold:
          type: integer
        periodSeconds:
          type: integer
      description: >
        Startup, liveness, or readiness probe. Configure one handler per probe:
        httpGet, tcpSocket, or grpc.
      title: Probe
    Container:
      type: object
      properties:
        image:
          type: string
          description: Container image reference.
        name:
          type: string
          description: Optional container name. Generated if omitted.
        command:
          type: array
          items:
            type: string
          description: Entrypoint command.
        args:
          type: array
          items:
            type: string
          description: Command arguments.
        workingDir:
          type: string
          description: Working directory inside the container.
        ports:
          type: array
          items:
            $ref: '#/components/schemas/ContainerPort'
        env:
          type: array
          items:
            $ref: '#/components/schemas/EnvVar'
        resources:
          $ref: '#/components/schemas/ResourceRequirements'
        volumeMounts:
          type: array
          items:
            $ref: '#/components/schemas/VolumeMount'
        startupProbe:
          $ref: '#/components/schemas/Probe'
        livenessProbe:
          $ref: '#/components/schemas/Probe'
        readinessProbe:
          $ref: '#/components/schemas/Probe'
      required:
        - image
      description: Application or sidecar container.
      title: Container
    KeyToPath:
      type: object
      properties:
        key:
          type: string
          description: Secret version or key.
        path:
          type: string
          description: Relative file path inside the volume.
      required:
        - key
        - path
      title: KeyToPath
    SecretVolumeSource:
      type: object
      properties:
        secretName:
          type: string
          description: Secret name.
        items:
          type: array
          items:
            $ref: '#/components/schemas/KeyToPath'
      required:
        - secretName
      description: Secret-backed volume.
      title: SecretVolumeSource
    EmptyDirVolumeSourceMedium:
      type: string
      enum:
        - Memory
      description: Storage medium.
      title: EmptyDirVolumeSourceMedium
    EmptyDirVolumeSource:
      type: object
      properties:
        sizeLimit:
          type: string
          description: Maximum size of the volume.
        medium:
          $ref: '#/components/schemas/EmptyDirVolumeSourceMedium'
          description: Storage medium.
      description: Ephemeral in-memory or disk-backed volume.
      title: EmptyDirVolumeSource
    CsiVolumeSourceDriver:
      type: string
      enum:
        - gcsfuse.api.agentmachines.app
      description: CSI driver name.
      title: CsiVolumeSourceDriver
    CSIVolumeAttributes:
      type: object
      properties:
        bucketName:
          type: string
          description: Bucket or object store container name.
        mountOptions:
          type: string
          description: Comma-separated mount options.
      description: Driver-specific attributes for the CSI volume.
      title: CSIVolumeAttributes
    CSIVolumeSource:
      type: object
      properties:
        driver:
          $ref: '#/components/schemas/CsiVolumeSourceDriver'
          description: CSI driver name.
        readOnly:
          type: boolean
          description: Whether the mounted volume is read-only.
        volumeAttributes:
          $ref: '#/components/schemas/CSIVolumeAttributes'
      required:
        - driver
      description: CSI-backed volume.
      title: CSIVolumeSource
    NFSVolumeSource:
      type: object
      properties:
        server:
          type: string
          description: NFS server IP address or hostname.
        path:
          type: string
          description: Export path on the NFS server.
        readonly:
          type: boolean
          description: Whether the mounted NFS volume is read-only.
      required:
        - server
        - path
      description: NFS-backed volume.
      title: NFSVolumeSource
    Volume:
      type: object
      properties:
        name:
          type: string
        secret:
          $ref: '#/components/schemas/SecretVolumeSource'
        emptyDir:
          $ref: '#/components/schemas/EmptyDirVolumeSource'
        csi:
          $ref: '#/components/schemas/CSIVolumeSource'
        nfs:
          $ref: '#/components/schemas/NFSVolumeSource'
      required:
        - name
      description: Named volume. Exactly one volume source should be set.
      title: Volume
    RevisionSpec:
      type: object
      properties:
        containerConcurrency:
          type: integer
          description: >-
            Maximum concurrent requests per instance. Use 0 for platform
            default.
        timeoutSeconds:
          type: integer
          description: Request timeout in seconds.
        nodeSelector:
          $ref: '#/components/schemas/NodeSelector'
        serviceAccountName:
          type: string
          description: Service account identity used by instances.
        containers:
          type: array
          items:
            $ref: '#/components/schemas/Container'
          description: Ordered list of application and sidecar containers.
        volumes:
          type: array
          items:
            $ref: '#/components/schemas/Volume'
          description: Volumes available to containers.
        runtimeClassName:
          type: string
          description: Runtime class or base image update setting.
      required:
        - containers
      description: Runtime configuration for one generated service revision.
      title: RevisionSpec
    RevisionTemplate:
      type: object
      properties:
        metadata:
          $ref: '#/components/schemas/RevisionTemplateMeta'
        spec:
          $ref: '#/components/schemas/RevisionSpec'
      required:
        - spec
      description: Template used to create new immutable revisions.
      title: RevisionTemplate
    TrafficTarget:
      type: object
      properties:
        percent:
          type: integer
          description: Percentage of traffic routed to this target.
        latestRevision:
          type: boolean
          description: Route traffic to the latest ready revision.
        revisionName:
          type: string
          description: Route traffic to a named revision.
        tag:
          type: string
          description: Optional stable tag for this traffic target.
        url:
          type: string
          format: uri
      description: Traffic allocation target.
      title: TrafficTarget
    ServiceSpec:
      type: object
      properties:
        template:
          $ref: '#/components/schemas/RevisionTemplate'
        traffic:
          type: array
          items:
            $ref: '#/components/schemas/TrafficTarget'
          description: Traffic allocation across revisions and tags.
      required:
        - template
      description: Desired service state.
      title: ServiceSpec
    ConditionStatus:
      type: string
      enum:
        - 'True'
        - 'False'
        - Unknown
      title: ConditionStatus
    Condition:
      type: object
      properties:
        type:
          type: string
        status:
          $ref: '#/components/schemas/ConditionStatus'
        reason:
          type: string
        message:
          type: string
        lastTransitionTime:
          type: string
          format: date-time
      description: Condition describing reconciliation or readiness.
      title: Condition
    Addressable:
      type: object
      properties:
        url:
          type: string
          format: uri
      description: Addressable service endpoint.
      title: Addressable
    ServiceStatus:
      type: object
      properties:
        observedGeneration:
          type: integer
          format: int64
        conditions:
          type: array
          items:
            $ref: '#/components/schemas/Condition'
        url:
          type: string
          format: uri
        address:
          $ref: '#/components/schemas/Addressable'
        latestCreatedRevisionName:
          type: string
        latestReadyRevisionName:
          type: string
        traffic:
          type: array
          items:
            $ref: '#/components/schemas/TrafficTarget'
      description: Observed state of a service.
      title: ServiceStatus
    AgentMachinesService:
      type: object
      properties:
        apiVersion:
          $ref: '#/components/schemas/AgentMachinesServiceApiVersion'
          description: Agent Machines service API version.
        kind:
          $ref: '#/components/schemas/AgentMachinesServiceKind'
          description: Resource kind.
        metadata:
          $ref: '#/components/schemas/ObjectMeta'
        spec:
          $ref: '#/components/schemas/ServiceSpec'
        status:
          $ref: '#/components/schemas/ServiceStatus'
      required:
        - apiVersion
        - kind
        - metadata
        - spec
      description: Top-level Agent Machines service manifest.
      title: AgentMachinesService
    ListServicesResponse:
      type: object
      properties:
        apiVersion:
          type: string
        kind:
          type: string
        metadata:
          $ref: '#/components/schemas/ListMeta'
        items:
          type: array
          items:
            $ref: '#/components/schemas/AgentMachinesService'
        unreachable:
          type: array
          items:
            type: string
      description: List response for services.
      title: ListServicesResponse
    ErrorError:
      type: object
      properties:
        code:
          type: integer
        message:
          type: string
        status:
          type: string
        details:
          type: array
          items:
            type: object
            additionalProperties:
              description: Any type
      required:
        - code
        - message
      title: ErrorError
    Error:
      type: object
      properties:
        error:
          $ref: '#/components/schemas/ErrorError'
      required:
        - error
      description: Error response body.
      title: Error
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{
  "apiVersion": "serving.agentmachines.app/v1",
  "kind": "ServiceList",
  "metadata": {
    "resourceVersion": "123456789",
    "continue": "token-abc123"
  },
  "items": [
    {
      "apiVersion": "serving.agentmachines.app/v1",
      "kind": "Service",
      "metadata": {
        "name": "web",
        "namespace": "project-123456",
        "labels": {
          "api.agentmachines.app/location": "us-central1"
        },
        "annotations": {
          "api.agentmachines.app/custom-audiences": "[\"dashboard\",\"internal\"]",
          "api.agentmachines.app/launch-stage": "GA",
          "api.agentmachines.app/description": "Primary web frontend service",
          "api.agentmachines.app/ingress": "all",
          "api.agentmachines.app/binary-authorization": "prod-policy",
          "api.agentmachines.app/binary-authorization-breakglass": "emergency override for deployment",
          "api.agentmachines.app/minScale": "2",
          "api.agentmachines.app/maxScale": "10",
          "api.agentmachines.app/function-target": "HandleRequest",
          "api.agentmachines.app/invoker-iam-disabled": "true",
          "api.agentmachines.app/iap-enabled": "true",
          "api.agentmachines.app/scalingMode": "automatic",
          "api.agentmachines.app/manualInstanceCount": "3"
        },
        "generateName": "web-",
        "uid": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
        "resourceVersion": "987654321",
        "generation": 3,
        "creationTimestamp": "2024-01-15T09:30:00Z",
        "deletionTimestamp": "2024-02-01T12:00:00Z",
        "finalizers": [
          "foregroundDeletion"
        ]
      },
      "spec": {
        "template": {
          "spec": {
            "containers": [
              {
                "image": "gcr.io/project-123456/web:2.1.0",
                "name": "web",
                "command": [
                  "/start-web"
                ],
                "args": [
                  "--port=8080",
                  "--log-level=info"
                ],
                "workingDir": "/app",
                "ports": [
                  {
                    "containerPort": 8080,
                    "name": "http1"
                  }
                ],
                "env": [
                  {
                    "name": "ENVIRONMENT",
                    "value": "production"
                  },
                  {
                    "name": "DATABASE_PASSWORD",
                    "valueFrom": {
                      "secretKeyRef": {
                        "name": "db-credentials",
                        "key": "password",
                        "optional": false
                      }
                    }
                  }
                ],
                "resources": {
                  "limits": {
                    "cpu": "2",
                    "memory": "1Gi",
                    "nvidia.com/gpu": "1"
                  }
                },
                "volumeMounts": [
                  {
                    "name": "config-volume",
                    "mountPath": "/etc/config"
                  }
                ],
                "startupProbe": {
                  "httpGet": {
                    "port": 8080,
                    "path": "/healthz",
                    "httpHeaders": [
                      {
                        "name": "X-Health-Check",
                        "value": "true"
                      }
                    ]
                  },
                  "initialDelaySeconds": 10,
                  "timeoutSeconds": 5,
                  "successThreshold": 1,
                  "failureThreshold": 3,
                  "periodSeconds": 10
                },
                "livenessProbe": {
                  "httpGet": {
                    "port": 8080,
                    "path": "/live",
                    "httpHeaders": [
                      {
                        "name": "X-Liveness-Probe",
                        "value": "true"
                      }
                    ]
                  },
                  "initialDelaySeconds": 30,
                  "timeoutSeconds": 5,
                  "successThreshold": 1,
                  "failureThreshold": 3,
                  "periodSeconds": 15
                },
                "readinessProbe": {
                  "httpGet": {
                    "port": 8080,
                    "path": "/ready",
                    "httpHeaders": [
                      {
                        "name": "X-Readiness-Probe",
                        "value": "true"
                      }
                    ]
                  },
                  "initialDelaySeconds": 5,
                  "timeoutSeconds": 3,
                  "successThreshold": 1,
                  "failureThreshold": 3,
                  "periodSeconds": 10
                }
              }
            ],
            "containerConcurrency": 80,
            "timeoutSeconds": 300,
            "nodeSelector": {
              "api.agentmachines.app/accelerator": "nvidia-l4"
            },
            "serviceAccountName": "web-service-account@project-123456.iam.gserviceaccount.com",
            "volumes": [
              {
                "name": "config-volume",
                "secret": {
                  "secretName": "web-config",
                  "items": [
                    {
                      "key": "config.yaml",
                      "path": "config.yaml"
                    }
                  ]
                },
                "emptyDir": {
                  "sizeLimit": "512Mi",
                  "medium": "Memory"
                },
                "csi": {
                  "driver": "gcsfuse.api.agentmachines.app",
                  "readOnly": true,
                  "volumeAttributes": {
                    "bucketName": "project-123456-web-config",
                    "mountOptions": "implicit-dirs,uid=1000"
                  }
                },
                "nfs": {
                  "server": "10.0.0.5",
                  "path": "/exports/web-data",
                  "readonly": true
                }
              }
            ],
            "runtimeClassName": "gvisor"
          },
          "metadata": {
            "name": "web-00001",
            "labels": {},
            "annotations": {
              "autoscaling.agentmachines.app/minScale": "2",
              "autoscaling.agentmachines.app/maxScale": "10",
              "api.agentmachines.app/scaling-cpu-target": "75",
              "api.agentmachines.app/scaling-concurrency-target": "100",
              "api.agentmachines.app/cpu-throttling": "true",
              "api.agentmachines.app/startup-cpu-boost": "true",
              "api.agentmachines.app/sessionAffinity": "true",
              "api.agentmachines.app/cloudsql-instances": "project-123456:us-central1:db-instance",
              "api.agentmachines.app/execution-environment": "gen1",
              "api.agentmachines.app/vpc-access-connector": "projects/project-123456/locations/us-central1/connectors/vpc-connector-1",
              "api.agentmachines.app/vpc-access-egress": "all-traffic",
              "api.agentmachines.app/network-interfaces": "[{\"name\":\"eth0\",\"subnet\":\"default\"}]",
              "api.agentmachines.app/encryption-key": "projects/project-123456/locations/us-central1/keyRings/my-keyring/cryptoKeys/my-key",
              "api.agentmachines.app/container-dependencies": "{\"web\": [\"init\"]}",
              "api.agentmachines.app/base-images": "{\"web\": \"gcr.io/project-123456/web-base:1.0\"}",
              "api.agentmachines.app/gpu-zonal-redundancy-disabled": "true"
            }
          }
        },
        "traffic": [
          {
            "percent": 100,
            "latestRevision": true,
            "revisionName": "web-00001",
            "tag": "stable",
            "url": "https://web.project-123456.agentmachines.app"
          }
        ]
      },
      "status": {
        "observedGeneration": 3,
        "conditions": [
          {
            "type": "Ready",
            "status": "True",
            "reason": "ServiceReady",
            "message": "Service is ready to serve traffic",
            "lastTransitionTime": "2024-01-15T09:45:00Z"
          }
        ],
        "url": "https://web.project-123456.agentmachines.app",
        "address": {
          "url": "https://web.project-123456.agentmachines.app"
        },
        "latestCreatedRevisionName": "web-00001",
        "latestReadyRevisionName": "web-00001",
        "traffic": [
          {
            "percent": 100,
            "latestRevision": true,
            "revisionName": "web-00001",
            "tag": "stable",
            "url": "https://web.project-123456.agentmachines.app"
          }
        ]
      }
    }
  ],
  "unreachable": [
    "us-east1"
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.agentmachines.app/apis/serving.agentmachines.app/v1/namespaces/project-123456/services"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.agentmachines.app/apis/serving.agentmachines.app/v1/namespaces/project-123456/services';
const options = {
  method: 'GET',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.agentmachines.app/apis/serving.agentmachines.app/v1/namespaces/project-123456/services"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.agentmachines.app/apis/serving.agentmachines.app/v1/namespaces/project-123456/services")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.agentmachines.app/apis/serving.agentmachines.app/v1/namespaces/project-123456/services")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.agentmachines.app/apis/serving.agentmachines.app/v1/namespaces/project-123456/services', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.agentmachines.app/apis/serving.agentmachines.app/v1/namespaces/project-123456/services");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.agentmachines.app/apis/serving.agentmachines.app/v1/namespaces/project-123456/services")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```